// Cabecalho para Funcoes de Manipulacao de Video
#include <dos.h>
#include <mem.h>

#define modoatual * (int *) MK_FP(0x40, 0x49)

// setavideo(int modo)
// Objetivo: Seta o video para o modo desejado
// Parametros: modo - numero do modo de video
void setavideo(int modo)
{
   union REGS regs;

   regs.h.al = (unsigned char) modo;
   regs.h.ah = 0;
   int86(0x10,&regs,&regs);
}


// setapaleta(char far *cores)
// Seta a Paleta de video com as cores armazenadas em cores
// Parametros:
//     Cores : ponteiro para um vetor contendo a intensidade das cores
void setapaleta(char far *cores)
{
   union REGS regs;
   struct SREGS sregs;
   unsigned int coroff = FP_OFF(cores),
		corseg = FP_SEG(cores);

     sregs.es = corseg;
     regs.h.ah = 0x10;
     regs.h.al = 0x12;
     regs.x.bx = 0;
     regs.x.cx = 0x100;
     regs.x.dx = coroff;
     int86x(0x10,&regs,&regs,&sregs);
}



// EsperaRetraco
// Objetivo: Aguardar o retraco vertical do video
//      A funcao retorna o controle ao programa quando um
//      novo retraco acabou de iniciar.
void esperaretraco()
{
   const
     int porta = 0x3da;
   unsigned char lido;

   //Espera retraco terminar
   do {
     lido = inportb(porta);
   } while (lido & 8);

   //Espera retraco reiniciar
   do {
     lido = inportb(porta);
   } while (!(lido & 8));

}
